//Parallele Portein-/ausgabe ber PortA
//zur Verbindung zum KC87 0xF0
//PA0-PA3 Output, PA4,5 Input,PA6,7 outp
#include <string.h>
#include <avr/io.h>
//########################################################
void putp (unsigned char c)  //parallel Ausgabe
//########################################################
  {
    DDRA=0xcf; 							//Alles ausg, 4+5 eing
	PORTA=0xFF; 						//Eingnge mit Pullups setzen
	unsigned char b;
	b=c;
	PORTA = ((b  & 0x0f) | 0x80);		//l nibble ausgeben
	while(!((PINA & 0x30)==0x10));  	//auf ready=1.nibble(low) warten
	PORTA = ((c >>4)& 0x0f);			//h nibble ausgeben
	while(!((PINA & 0x30) == (0x00)));	//auf ready=2.nibble(hi) warten
	while(!((PINA & 0x30) ==0x30));		//warten auf ready
	PORTA = 0xff;						//busy
	
  }

//########################################################
unsigned char getp (void)  //parallel Eingabe
//########################################################
 {
    DDRA=0xc0; 						//Alles eing 6+7 ausg
	PORTA=0xFF; 					//Eingnge mit Pullups setzen
	unsigned char c;
	unsigned char b;
	PORTA &= ~(1<<PA7); 			// bit lschen bereit fr 1. nibble (l)
	while(!((PINA & 0x30)==0x20));  //auf ready=1.nibble(low) warten		
	c=PINA & 0x0f;					//Port lesen
	PORTA &= ~(1<<PA6);				//bereit fr 2. nibble (h)
	while(!((PINA & 0x30)==0x00));  //auf ready=2.nibble(lh) warten
	b=PINA & 0x0f; 					//Port lesen
	PORTA = 0xff; 					//busy
	c=c+ (b<<4);					//Byte zusammensetzen
	return (c);
 }
//########################################################
unsigned char Command(void) //fr Tastenabfragen im Command
//muss immer mit Enter (0x0d) abgeschlossen werden
//########################################################
 {
	char c, s[2];
	char line[3];
	size_t strcspn();
	s[1]=0;
	strcpy(line,"\0");
 	do
  	{
   		c=getp();
   		if(c!=0x0D && c!=0x08 && c!=0x01){ s[0]=c;strcat(line,s);}
   		if(c==0x08 && strlen(line)>0) line[strlen(line)-1]=0; //DEL
   		if(c==0x01 && strlen(line)>0) line[strlen(line)-1]=0; //DEL
	}while(c!=0x0D);
 c = line[0];
 return (c);
 }

  

