#!/usr/bin/perl
# vp 11.06.2003 erstellt
# 07.05.2007
# 24.05.2008 aadr ergnzt
# 14.06.2008 sadr ergnzt

die <<HELP unless @ARGV;
Aufruf: com2tap bin-file [blocknr] [aadr] [sadr]
konvertiert (CP/M) COM-Dateien ins AF-TAP-Format

HELP

$blocknr = $ARGV[1] || 0;
$aadr = (oct '0x'.$ARGV[2]) || 0x100;
$sadr = (oct '0x'.$ARGV[3]) || $aadr;

($OUT = $ARGV[0]) =~ s/\..*/.tap/i;

open IN, "<$ARGV[0]";
binmode IN;

open OUT, ">$OUT";
binmode OUT;

print "Schreibe $OUT ";


#Kopfblock schreiben
$name=uc $ARGV[0];
$name =~ s/\.(.*)//;
$size= -s $ARGV[0];

print "NAME=$name SIZE=$size\n";

#Header schreiben
print OUT 'KC-TAPE by AF. ';

$blocknr = $blocknr;
print OUT pack("C",$blocknr++);		# 1. Block fr MC

#KC-Header
print OUT pack("
	a8		   # dateiname: array[0..7] of char;
	a3		   # dateityp: array[0..2] of char;
	xx		   # e1, e2: byte;
	xxxc		   # psum, arb, blnr, lblnr: byte;
	sss		   # aadr, eadr, sadr: word;
	x		   # sby: byte;
	", $name, 'COM', 3, $aadr, $aadr+$size, $sadr
);

print OUT "\x00"x(128-24);  # 1. Block fr MC mit 00 auffllen

#Daten schreiben
until (eof IN) {
	read IN, $block, 128; 
	if (eof (IN)) { $blocknr = 255 }	# der letzte Block erhlt die Nr. FF
	print OUT pack("C",$blocknr++);
	print OUT pack("a128", $block);
}

close IN;
close OUT;
